/*
	API Readme.c
	
	This is a summary of the routine name prefixes and how they are used.  Most of the information
	comes from a table from Quinn's develop article.
	
	Prefix			Part of Sytem			First Parameter			GetPref Specification
	
	IC				Standard API			ICInstance					ICError ICGetPref(ICInstance inst,StringPtr key,...);
					(switch glue)
	
	ICC				Component API			ComponentInstance			ICError ICCGetPref(ComponentInstance inst,StringPtr key,...);
					(component glue)
	
	ICCI				Component Internal		GlobalsHandle				ICError ICCIGetPref(GlobalsHandle inst,StringPtr key,...);
	
	ICR				Linked In Code			ICRRecordPtr				ICError ICRGetPref(ICRRecordPtr inst,StringPtr key,...);
	
	The standard API routines provide a switch between the component routines and the linked in code routines.  This should provide
	a transparent interface to the Internet Config system without having to worry about the presence of the Component Manager or the
	IC Component.
	
	The component API routines are the interface to the IC Component.  These routines are mostly glue to call the component through
	the Component Manager with the proper message (for more information about components, see the references in a separate doc).
	
	The linked in code is the main guts for the system (the component calls the linked in code routines internally).  These routines use
	the Resource Manager to access the IC config file.
	
*/



	
	