/*
	IC Keys.h
	
	This header file defines some keys which are predefined to exist as part of the IC prefs file.
	
	Keys can be added by an IC-aware application.
	
	The canonical Internet Config interface is defined in Pascal.  These headers have
	not been thoroughly tested.  If there is a conflict between these headers and the
	Pascal interfaces, the Pascal should take precedence.
*/

#ifndef __H_IC_Keys__
#define __H_IC_Keys__

#define kICRealName				"\pRealName"				/* PString */
#define kICEmail					"\pEmail"					/* PString -- user@host.domain */
#define kICMailAccount			"\pMailAccount"				/* PString -- user@host.domain */
#define kICMailPassword			"\pMailPassword"			/* PString -- scrambled */
#define kICNewsAuthUsername		"\pNewsAuthUsername"		/* PString */
#define kICNewsAuthPassword		"\pNewsAuthPassword"		/* PString -- scrambled */
#define kICArchiePreferred		"\pArchiePreferred"			/* PString -- formatted */
#define kICArchieAll				"\pArchieAll"				/* STR# -- formatted */
#define kICUMichPreferred		"\pUMichPreferred"			/* PString -- formatted */
#define kICUMichAll				"\pUMichAll"				/* STR# -- formatted */
#define kICInfoMacPreferred		"\pInfoMacPreferred"		/* PString -- formatted */
#define kICInfoMacAll			"\pInfoMacAll"				/* STR# -- formatted */
#define kICPhHost				"\pPhHost"					/* PString -- host.domain */
#define kICWhoisHost				"\pWhoisHost"				/* PString -- host.domain */
#define kICFingerHost			"\pFingerHost"				/* PString -- host.domain */
#define kICFTPHost				"\pFTPHost"					/* PString -- host.domain */
#define kICTelnetHost			"\pTelnetHost"				/* PString -- host.domain */
#define kICSMTPHost				"\pSMTPHost"				/* PString -- host.domain */
#define kICNNTPHost				"\pNNTPHost"				/* PString -- host.domain */
#define kICGopherHost			"\pGopherHost"				/* PString -- host.domain */
#define kICLDAPServer			"\pLDAPServer"				/* PString -- host.domain */
#define kICLDAPSearchbase		"\pLDAPSearchbase"			/* PString -- string LDAP thing */
#define kICWWWHomePage			"\pWWWHomePage"			/* PString -- URL */
#define kICWAISGateway			"\pWAISGateway"			/* PString -- no idea */
#define kICListFont				"\pListFont"					/* ICFontRecord */
#define kICScreenFont			"\pScreenFont"				/* ICFontRecord */
#define kICPrinterFont			"\pPrinterFont"				/* ICFontRecord */
#define kICTextCreator			"\pTextCreator"				/* ICAppSpec */
#define kICBinaryTypeCreator		"\pBinaryTypeCreator"		/* ICFileInfo */
#define kICDownloadFolder		"\pDownloadFolder"			/* ICFileSpec */
#define kICSignature				"\pSignature"				/* TEXT */
#define kICOrganization			"\pOrganization"				/* PString */
#define kICPlan					"\pPlan"					/* TEXT */
#define kICQuotingString			"\pQuotingString"			/* PString */
#define kICMailHeaders			"\pMailHeaders"				/* TEXT */
#define kICNewsHeaders			"\pNewsHeaders"			/* TEXT */
#define kICMapping				"\pMapping"					/* ICMapEntries */
#define kICCharacterSet			"\pCharacterSet"			/* ICCharTable */
#define kICHelper				"\pHelper"					/* ICAppSpec */
#define kICServices				"\pServices"				/* ICServices */
#define kICNewMailFlashIcon		"\pNewMailFlashIcon"		/* Boolean */
#define kICNewMailDialog			"\pNewMailDialog"			/* Boolean */
#define kICNewMailPlaySound		"\pNewMailPlaySound"		/* Boolean */
#define kICNewMailSoundName		"\pNewMailSoundName"		/* PString */
#define kICWebBackgroundColour	"\pWebBackgroundColour"		/* RGBColor */
#define kICNoProxyDomains		"\pNoProxyDomains"			/* STR# -- list of domains */
#define kICUseSocks				"\pUseSocks"				/* Boolean */
#define kICSocksHost				"\pSocksHost"				/* PString -- host.domain */
#define kICUseHTTPProxy			"\pUseHTTPProxy"			/* Boolean */
#define kICHTTPProxyHost		"\pHTTPProxyHost"			/* PString -- host.domain */
#define kICUseFTPProxy			"\pUseFTPProxy"			/* Boolean */
#define kICFTPProxyHost			"\pFTPProxyHost"			/* PString -- host.domain */
#define kICFTPProxyUser			"\pFTPProxyUser"			/* PString */
#define kICFTPProxyPassword		"\pFTPProxyPassword"		/* PString -- scrambled */
#define kICFTPProxyAccount		"\pFTPProxyAccount"		/* PString */

#endif /* __H_IC_Keys__ */





