/*
	Libsprintf.h
	
	Header file for Libsprintf.c
	
*/

#pragma once

// Uncomment the following to use the ANSI sprintf
// #define _USE_ANSI_ 1

#ifndef __H_Libsprintf__
#define __H_Libsprintf__

#ifdef _USE_ANSI_

#include <stdio.h>
#include <string.h>

#else /* !_USE_ANSI_ */

// a replacement for ANSI's errno
extern long s_errno;

#ifdef __cplusplus
extern "C" {
#endif

int libsprintf(char *fp, const char *fmt,...);
int libvsprintf(char *fp, const char *fmt,void*);

void libfixnl(char* buf);
char libstrlen(char* buf);

#ifdef __cplusplus
}
#endif

#endif /* _USE_ANSI_ */

#endif /* __H_Libsprintf__ */
