#include <stdio.h>
#include <stdlib.h>

#include <Folders.h>

#include "IC Types.h"
#include "IC Keys.h"

#include "IC R API.h"

#ifdef DEBUG_ICRAPI
#include "syslog.h"
#endif

ICRRecord gRec;

void DumpPrefs(void);

int main(void){
	ICError err;
	ICDirSpecArray folder_spec;
	Str255 email;
	long attr,size,seed;
	short vref;
	long dirid;
	FSSpec spec;
	
#ifdef DEBUG_ICRAPI
	// set up the syslog file...
	err=(ICError)FindFolder(kOnSystemDisk,kDesktopFolderType,kCreateFolder,&vref,&dirid);
	FSMakeFSSpec(vref,dirid,"\pIC Link In Log",&spec);
	setsyslogfile(&spec);
#endif
	
	printf("\nIC Link In Code Test\n\n");
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"IC Link In Code Test Begin");
#endif
	
	err=ICRStart(&gRec,'PPCt');
	printf("ICRStart: %ld\n",err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRStart: %ld",err);
#endif
	
	err=(ICError)FindFolder(kOnSystemDisk,kPreferencesFolderType,kCreateFolder,&vref,&dirid);
	printf("FindFolder: %ld\n",err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"FindFolder: %ld",err);
#endif
	
	folder_spec[0].vRefNum=vref;
	folder_spec[0].dirID=dirid;
	
	err=ICRFindConfigFile(&gRec,1,folder_spec);
	printf("ICRFindConfigFile: %ld\n",err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRFindConfigFile: %ld",err);
#endif
	
	err = ICRBegin(&gRec, icReadWritePerm);
	printf("ICRBegin: %ld\n", err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRBegin: %ld",err);
#endif
	
	size = sizeof(Str255);
	err = ICRGetPref(&gRec, "\pEmail", &attr, (Ptr) email, &size);
	printf("ICRGetPref: %ld\n", err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRGetPref: %ld",err);
#endif
	
	p2cstr(email);
	printf("Your Email address is [%s]\n", email);
#ifdef DEBUG_ICRAPI
	syslog(LOG_INFO,"Your Email address is [%s]",email);
#endif
	
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"Dumping Prefs");
#endif
	DumpPrefs();
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"Prefs Dumped");
#endif
	
	err = ICREnd(&gRec);
	printf("ICREnd: %ld\n", err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICREnd: %ld",err);
#endif
	
	err = ICRGetSeed(&gRec, &seed);
	printf("ICRGetSeed: %ld, seed= %ld\n", err, seed);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRGetSeed: %ld, seed=%ld",err,seed);
#endif
	
	/* now monitor this seed to see if any preferences have changed */
	
	err=ICRStop(&gRec);
	printf("ICRStop: %ld\n",err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRStop: %ld",err);
#endif
	
	return 0;
}

void DumpPrefs(void){
	ICError err;
	long count;
	long i;
	Str255 key;
	
	err = ICRCountPref(&gRec, &count);
	printf("ICRCountPref: %ld\n", err);
#ifdef DEBUG_ICRAPI
	syslog(LOG_DEBUG,"ICRCountPref: %ld, count=%ld",err,count);
#endif
	
	for (i = 1; i <= count; i++) {
		err = ICRGetIndPref(&gRec, i, key);
		p2cstr(key);
		printf("  ICRGetIndPref: %ld - %s\n", err, &key);
#ifdef DEBUG_ICRAPI
		syslog(LOG_DEBUG,"ICRGetIndPref: %ld, key=[%s]",err,key);
#endif
	};
}


